/* xutil.h
 *
 * Copyright (C) 2005, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

#ifndef XUTIL_H
#define XUTIL_H


typedef void (*XFree_f)  (void *data);
typedef int  (*XCmp_f)   (const void *a, const void *b);

typedef unsigned char xbool_t;


#define FALSE 0
#define TRUE  1

#define BOOL(x)             (!(!(x)))

#define SET_BIT(x, b)       ((x) |= (1<<(b)))
#define CLEAR_BIT(x, b)     ((x) &= ~(1<<(b)))
#define FLIP_BIT(x, b)      ((x) ^= (1<<(b)))
#define TEST_BIT(x, b)      ((x) & (1<<(b)))

#define MIN(a, b)           ((a) <= (b) ? (a) : (b))
#define MAX(a, b)           ((a) >= (b) ? (a) : (b))

#define N_ELEMENTS(array)   (sizeof(array) / sizeof((array)[0]))

#define OVERFLOW(a, b)      ((a) > (INT_MAX - (b)))   /* for a >= 0 */
#define UOVERFLOW(a, b)     ((a) > (UINT_MAX - (b)))  /* for a >= 0 */

#define XRAND(x)            (rand () / (RAND_MAX / (x) + 1))


#endif /* XUTIL_H */

